/***************************************************************************
 *   Copyright (C) 2008 by Dirk Hartmann                                   *
 *   2monex@gmx.net                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef UPDATERPMSTATUSTHREAD_H
#define UPDATERPMSTATUSTHREAD_H

#include <QThread>
#include <QMap>
#include <QUrlInfo>

#include "rpm.h"
#include "repositoryprofile.h"

class QFtp;


class UpdateRpmStatusThread : public QThread
{
	Q_OBJECT
	public:
		UpdateRpmStatusThread(QObject *parent = 0);
		
		int posOfProcessedProfile() const {return profilePos;}
		void setPosOfProcessedProfile(const int pos);
		
		QMap<QString, Rpm> getRpms() const {return currentProfile.getRpms();}
		void setRpms(const QMap<QString, Rpm> & rpms);
		
		RepositoryProfile getProfile() const {return currentProfile;}
		void setProfile(const RepositoryProfile &profile);

		~UpdateRpmStatusThread();
	
	protected:
		void run();
	
	private slots:
		void gotFtpListEntry(QUrlInfo info);
		void ftpRequestFinished(bool success);
		void ftpCommandStarted(int id);
		void ftpStateChanged(int i);
	
	private:
		void updateRpmLists();
		void updateNextItem();
		QMap<QString, QStringList> getRpmLists() const;
	
		RepositoryProfile currentProfile;
		int profilePos;
		QFtp *ftp;
		QMap<QString, QStringList> rpmLists; // architecture, rpm ftp/http list
		QString currentArch;

};

#endif
